import com.aspose.barcode.*;
import com.aspose.barcode.generation.BarcodeGenerator;

import java.awt.*;
import java.io.IOException;

public class GenerationExamples
{
    public static void main(String[] args) throws IOException
    {
        GenerationExamples generationExamples = new GenerationExamples();
        generationExamples.howToDefaultBorderColor();
        generationExamples.howToGenerateOneD();
        generationExamples.howToGenerateTwoD();
        generationExamples.howToGetBarcodeTypeAndCodeText();
        generationExamples.howToGetCodeText();
        generationExamples.howToGetDefaultBackColor();
        generationExamples.howToGetDefaultDashStyle();
        generationExamples.howToGetDefaultForeColor();
        generationExamples.howToSave();
        generationExamples.howToSetBackColor();
        generationExamples.howToSetBarcodeType();
        generationExamples.howToSetBorderColor();
        generationExamples.howToSetCodeText();
        generationExamples.howToSetFont();
        generationExamples.howToSetForeColor();
    }

    public final String subfolder = "resources/generating/";

    public void howToSave() throws IOException
    {
        SymbologyEncodeType type = EncodeTypes.CODE_39_STANDARD;
        String codeText = "123678943";
        BarcodeGenerator generator = new BarcodeGenerator(type, codeText);
        generator.save(subfolder + "howToSave.png");
    }

    public void howToSetBarcodeType() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
       BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_128, "12367891011");
        SymbologyEncodeType type_expected = EncodeTypes.CODABAR;
        generator.setBarcodeType(type_expected);
        generator.save(this.subfolder + "testSetBarcodeType.png");
        BaseEncodeType type_actual = generator.getBarcodeType();
        generator.save(this.subfolder + "howToSetBarcodeType.png");
        System.out.println("type_expected = " + type_expected + "\n");
        System.out.println("type_actual = " + type_actual + "\n");
    }

    public void howToGetCodeText() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        String expected = "1234567890DCBV";
       BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_128, expected);
        generator.save(this.subfolder + "howToGetCodeText.png");
        System.out.println("CodeText = " + generator.getCodeText());

    }

    public void howToGenerateOneD() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        String codeText = "01234567";
        SymbologyEncodeType encodeType = EncodeTypes.CODE_39_STANDARD;
        BarcodeGenerator generator = new BarcodeGenerator(encodeType, codeText);
        generator.save(this.subfolder + "howToGenerateOneD.png");
    }

    public void howToGenerateTwoD() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        String codeText = "01234567";
        SymbologyEncodeType encodeType = EncodeTypes.QR;
        BarcodeGenerator generator = new BarcodeGenerator(encodeType, codeText);
        generator.save(this.subfolder + "howToGenerateTwoD.png");
    }

    public void howToSetBackColor() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        Color color_expected = Color.RED;
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        generator.getParameters().setBackColor(color_expected);
        Color color_actual = generator.getParameters().getBackColor();
        generator.save(this.subfolder + "howToSetBackColor.png");
        System.out.println("color_expected = " + color_expected + "\n");
        System.out.println("color_actual = " + color_actual + "\n");
    }

    public void howToGetDefaultBackColor() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        String color_expected = "#FFFFFF";
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        Color color_actual = generator.getParameters().getBackColor();
        generator.save(this.subfolder + "howToGetDefaultBackColor.png");
        System.out.println("color_expected = " + color_expected + "\n");
        System.out.println("color_actual = " + color_actual + "\n");
    }

    public void howToGetDefaultForeColor() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        String color_expected = "#000000";
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        Color color_actual = generator.getParameters().getBarcode().getForeColor();
        generator.save(this.subfolder + "howToGetDefaultForeColor.png");
        System.out.println("Color expected = " + color_expected + "\n");
        System.out.println("Color actual = " + color_actual + "\n");
    }

    public void howToSetForeColor() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        Color color_expected = new Color(250, 0, 170);
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        generator.getParameters().getBarcode().setForeColor(color_expected);
        Color color_actual = generator.getParameters().getBarcode().getForeColor();
        generator.save(this.subfolder + "howToSetForeColor.png");
        System.out.println("Color expected = " + color_expected + "\n");
        System.out.println("Color actual = " + color_actual + "\n");
    }


    public void howToSetCodeText() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        SymbologyEncodeType encode_type = EncodeTypes.CODE_128;
        BarcodeGenerator generator = new BarcodeGenerator(encode_type, null);
        String expected = "555777";
        generator.setCodeText(expected);
        String actual = generator.getCodeText();
        generator.save(this.subfolder + "howToSetCodeText.png");
        System.out.println("CodeText actual = " + actual + "\n");
        System.out.println("CodeText expected = " + expected + "\n");
    }


    public void howToGetBarcodeTypeAndCodeText() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        SymbologyEncodeType encode_type_expected = EncodeTypes.AZTEC;
        String code_text_expected = "444555777665";
        BarcodeGenerator generator = new BarcodeGenerator(encode_type_expected, code_text_expected);
        BaseEncodeType encode_type_actual = generator.getBarcodeType();
        String code_text_actual = generator.getCodeText();
        generator.save(this.subfolder + "howToGetBarcodeTypeAndCodeText.png");
        System.out.println("code text actual = " + code_text_actual + "\n");
        System.out.println("code text expected = " + code_text_expected + "\n");
        System.out.println("encode type actual = " + encode_type_actual + "\n");
        System.out.println("encode type expected = " + encode_type_expected + "\n");
    }

    public void howToGetDefaultDashStyle() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        BorderDashStyle dash_style_expected = BorderDashStyle.SOLID;
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        BorderDashStyle dash_style_actual = generator.getParameters().getBorder().getDashStyle();
        generator.save(this.subfolder + "howToGetDefaultDashStyle.png");
        System.out.println("dash_style_actual = " + dash_style_actual + "\n");
        System.out.println("dash_style_expected" + dash_style_expected + "\n");
    }

    public void howToDefaultBorderColor() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        Color border_color_expected = Color.BLACK;
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        Color border_color_actual = generator.getParameters().getBorder().getColor();
        generator.save(this.subfolder + "howToDefaultBorderColor.png");
        System.out.println("border_color_expected = " + border_color_expected + "\n");
        System.out.println("border_color_actual = " + border_color_actual + "\n");
    }

    public void howToSetBorderColor() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
        Color border_color_expected = Color.MAGENTA;
        BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_39_STANDARD, "01234567");
        generator.getParameters().getBorder().setColor(border_color_expected);
        Color border_color_actual = generator.getParameters().getBorder().getColor();
        generator.save(this.subfolder + "howToSetBorderColor.png");
        System.out.println("border_color_expected = " + border_color_expected + "\n");
        System.out.println("border_color_actual = " + border_color_actual + "\n");
    }

    public void howToSetFont() throws IOException
    {
        System.out.println("\n---\nfunction '" + new Object(){}.getClass().getEnclosingMethod().getName() + "'\n");
       BarcodeGenerator generator = new BarcodeGenerator(EncodeTypes.CODE_128);
        generator.getParameters().getCaptionAbove().setText("CAPTION ABOOVE");
        generator.getParameters().getCaptionAbove().setVisible(true);
        generator.getParameters().getCaptionAbove().getFont().setStyle(FontStyle.ITALIC);
        generator.getParameters().getCaptionAbove().getFont().getSize().setPoint(5);
        String save_path = this.subfolder + "howToSetFont.bmp";
        generator.save(save_path);
    }
}
